/* $Id: CalcPitch.java,v 1.11 2011/10/11 06:16:54 mit Exp $ */
/* CalcPitch.java v0.9 */
import java.util.*;

public class CalcPitch implements Runnable {
    private final int KB = 88;
    private final int Oct = 12;
    private final int KC = KB+Oct*3; // by 44100
    private final int Cent = 1200;
    private final int Pmax = 20;      // ܲκ
    private final double MaxIH = 7.0; // IHκ
    private final double StartIH = -0.1; // IHη׻Ϥ(JP)
    private final double AA = 440.0;
    private final double ML = Math.log(2)/Cent/Math.log(10);
    private final double MC = Cent/Math.log(2);
    private final double PI2 = 2*Math.PI;
    private final double[] Ladder = {
        0.0, 0.0, -1.955, 0.0, 13.6863, -1.955, 31.1741, 0.0,
	-3.91, 13.6863, 48.6821, -1.955, -40.5277, 31.1741,
	11.7313, 0.0, -4.9554, -3.91, 2.487, 13.6863}; // 20
    private final int[] Multi = {
	0, 12, 19, 24, 28, 31, 34, 36, 38, 40,
	42, 43, 44, 46, 47, 48, 49, 50, 51, 52}; // 20

    private boolean[] Power; // FFT cutϰ
    private int NN, N2;
    private int Splngf;
    private int Start;  // wave start
    private int Wide;   // wave data
    private int Shift;  // wave shift
    private int Maxf;   // FFTڥȥΰ(<N2)
    private int[] Wave; // wave data
    private int[] Temp; // wave data(NN)
    private double Cmax;
    private double Delf;
    private double DT;        // 1/Splngf
    private double DevidTime; // shiftǤλ
    private double ValIH; //
    private double Level; // cliping
    private double Ymax;
    private double LsmA;
    private double LsmB;
    private double LsmR;
    private double[] Re;
    private double[] Im;
    private double[] Han;
    private double[] YY;
    private double[] MinSum; // Υǡ
    private String Error;
    private FFT fftN;
    private Pitch2[] Pk2;  // keyΥԡ
    private ArrayList<Peaks> Ps;  // FFTԡ
    private boolean Gsw;
    private boolean Runsw;
    private Thread th;

    private int ICount;    // ܲ
    private int SCount;    // Υǡ
    private int Frame;     // (devid)
    private int Loop;      // for run
    private int Stime = 10;// run sleep time
    private double MaxSum; // κ
    private double PIT;    // pitch
    private double INH;    // Inha.
    private Multiple[] Mu;

    public CalcPitch() { }
    public void initPitch(int[] wave, int splngf, int nn, int de,
			  int cnt, int stt, double lev, int cmx) {
	Wave = wave;
	Splngf = splngf;
	DT = 1.0/splngf;

	setWide(stt, cnt);
	setLevel(lev);
	setCmax(cmx);
	setSample(nn, de);

	reset_pitch();
    }
    public void setSample(int nn, int de) {
	NN = nn;
        N2 = NN/2;
        fftN = new FFT(NN);
        YY = new double[N2];
	Temp = new int[NN];
	resetPower();
	Ymax = 0;
	Maxf = 0;	

	initHanning();
	set_delf();
	if (Wide > 0)
	    setDevid(de);
    }
    public void set_delf() {
	Delf = Splngf/(double)NN;
    }
    public void setCmax(double cm) {
	Cmax = cm;
    }
    public void setDevid(int de) {
        int dev = (int)Math.pow(2, de);      // 1:2:4:8:16
	Shift = NN/dev;
	Frame = (int)Math.floor((Wide-(NN-Shift))/Shift);

	int cnt = (Wide-NN)/Shift;
	DevidTime = (Shift*cnt+NN)/(double)Splngf;
    }
    public void setWide(int stt, int cnt) {
	Start = stt;
	Wide = cnt;
    }
    public void setLevel(double lev) {
	Level = lev;
    }
    public void setStime(int st) {
	Stime = st;
    }
    //
    public void startRun() {
	reset_peak();
	Pitch2.resetPcounter();

        th = new Thread(this);
        th.start();
        Runsw = true;
    }
    public boolean isRun() {
        return Runsw;
    }
    public void stop() {
        if (th != null) {
            th = null;
            Runsw = false;
        }
    }
    public void run() {
	Maxf = 0;
	Ymax = 0;

        try {
            for (Loop = 0; Loop < Frame; Loop++) {
		if (Runsw == false)
		    break;
		System.arraycopy(Wave, Start+Loop*Shift, Temp, 0, NN);
		calcPitch(Temp, Loop, true);

		Pitch2.resetPcounter();
		peaks2pitch2();
		th.sleep(Stime);
            }

            System.arraycopy(Wave, Start, Temp, 0, NN); // ǽ1
            fft(Temp);
        }
        catch (InterruptedException e) {
            Error = ""+e;
            // System.out.println(e);
        } catch (Exception ex) {
	    Error = "CP run error";
	}

        Loop = 0;
        th = null;
        Runsw = false;
    }
    public void calc_one_time() {
        Loop = 0;
        System.arraycopy(Wave, Start, Temp, 0, NN);
	calcPitch(Temp, Loop, false);
	peaks2pitch2();
    }
    public void calcPitch(int[] data, int loop, boolean sw) {
	Gsw = sw; // loop sw.
	fft(data);

	if (!Gsw) { // not loop
	    reset_pitch();
	    reset_peak();
	}
	ifpk(loop);
    }
    public int getPnum() {
	return Pk2[0].getPcounter();
    }
    public int getFundKey() {
	return (getPnum() < 1) ? -1 : Pk2[0].getPkey();
    }
    public double getPower(int n) {
	return YY[n];
    }
    public double get_power(int n) {
	return (Power[n]) ? 0 : YY[n];
    }
    public boolean isPower(int n) {
	return Power[n];
    }
    public void setPower(int n) {
	Power[n] = true;
    }
    public void resetPower() {
	Power = new boolean[N2];
    }
    public double getYmax() {
	return Ymax;
    }
    public int getMaxf() {
	return Maxf;
    }
    public Pitch2 getPitch(int n) {
	return Pk2[n]; //
    }
    public void calcInharmo(int key, double vih, boolean asw) {
	this.setValIH(vih);
	sort();
	calc_multi_inha(key, asw);
    }
    public Multiple getMultiple(int n) {
	return Mu[n];
    }
    public int getICount() {
	return ICount;
    }
    public int getLoop() {
        return Loop;
    }
    public int getFrame() {
	return Frame;
    }
    public double getDevidTime() {
	return DevidTime;
    }
    public double getInharmo(int n) {
	return (Mu[n] != null) ? Mu[n].getInhar(PIT) : 0;
    }
    public double getICent(int n) {
	return (Mu[n] != null) ? Mu[n].getCpure() : 0;
    }
    public double getECent(int n) {
	return (Mu[n] != null) ? Mu[n].getCequal() : 0;
    }
    public double[] getMinSum() {
	return MinSum;
    }
    public double getMaxSum() {
	return MaxSum;
    }
    public double getStartIH() {
	return StartIH;
    }
    public double getPcent() {
	return PIT;
    }
    public int getSumCount() {
	return SCount-1;  // -1
    }
    public String getError() {
	return Error;
    }
    public double getINH() {
	return INH;
    }
    public double getLadder(int n) {
	if (n < 0 | n >= Pmax)
	    return -1;
	return Ladder[n];
    }
    public int getMulti(int n) {
	if (n < 0 | n >= Pmax)
	    return -1;
	return Multi[n];
    }
    public void setINH(double inh) {
	INH = inh;
    }
    public void setValIH(double vih) {
	ValIH = vih;
    }
    //
    public void reset_peak() {
	Ps = new ArrayList<Peaks>();
    }
    public void ifpk(int loop) {
	Error = "";
	Peaks ps;
	int ky, al;
	double beta, pk, fi;
	for (int i = 2; i < N2-1; i++) {
	    if (get_power(i) > Level) {
		if ((Math.abs(get_power(i)) >= Math.abs(get_power(i-1))) &&
		    (Math.abs(get_power(i)) >= Math.abs(get_power(i+1)))) {
		    beta = 3.0/(1+get_power(i)/get_power(i+1))-1;
		    pk = ((Math.PI*(1+beta)*beta*(1-beta))/
			  Math.sin(Math.PI*beta))*get_power(i); // ԡ
		    fi = (i+beta)*Delf;                     // ȿ
		    ky = ftok(fi);                          // #
		    if (ky < 0)                      // -keyϤʤ
			continue;
		    ps = new Peaks(ky, loop, fi);    //
		    al = getALsize();                // ޤǤ
		    if (al > 0 && isPeaks(al-1, ps)) // Ʊ...
			addFreq(al-1, fi);          // freqäΤ
		    else                           // Ǥʤ...  
			Ps.add(ps);               // ArrayListɲ
		    i += 2;
		} 
	    }
	}
    }
    public Peaks getAL(int nm) {
	return (Peaks)Ps.get(nm);
    }
    public void addFreq(int nm, double fq) {
        getAL(nm).resetPeaks(fq);
    }
    public double getPeaksf(int nm) { // freq.
	return getAL(nm).getPeaksF();
    }
    public int getPeaksk(int nm) {    // keynum
	return getAL(nm).getPeaksK();
    }
    public int getPeaksc(int nm) {    // count
	return getAL(nm).getPeaksC();
    }
    public int getALsize() {
	return Ps.size();
    }
    public double calcLSM(int nm) {
	return LsmA+LsmB*Math.pow(nm, 2);
    }
    public double getLsmA() {
	return LsmA;
    }
    public double getLsmB() {
	return LsmB;
    }
    public double getLsmR() {
	return LsmR;
    }
    public boolean isPeaks(int nm, Peaks ps) {
        return getAL(nm).isPeaks(ps);
    }
    public void peaks2pitch2() {
	boolean sw;
	int count;
	Peaks ps = new Peaks();
	Iterator it = Ps.iterator();
	while(it.hasNext()) {
	    sw = false;
	    try {
		ps = (Peaks)it.next();
	    } catch (Exception ex) {
		Error = ""+ex; // System.out.println(ex);
		break; // continueǤϥ롼?
	    }

	    count = Pitch2.getPcounter(); // 
	    for (int j = 0; j < count; j++) {
		if (Pk2[j] == null)
		    continue;
		else if (Pk2[j].isPitch(ps)) { // keyƱʤ...
		    Pk2[j].setPitch(ps);       // ...ɲ
		    sw = true;
		    break;
		}
	    }
	    if (!sw) // countϤΤޤޥ饹ͤˤʤ
		Pk2[count] = new Pitch2(ps); // key̵new
	}
    }
    //
    public void reset_pitch() {
	Pk2 = new Pitch2[KC+1];
	Pitch2.resetPcounter();
    }
    public void calc_multi_inha(int key, boolean sw) {
	double dt = 0.01; // 
	MinSum = new double[(int)((MaxIH-StartIH)/dt+1)]; // -ʤΤ-(diff)
	MaxSum = PIT = INH = ICount = SCount = 0; // ǽ˽
	Mu = new Multiple[Pmax]; // ܲclass

	int bsk = get_funda_key(key, sw); // 𲻤
	if (bsk < 0)
	    return;

	int maxp = Pk2[0].getPcounter(); // ԡ
	if (maxp < 1)  // ԡ̵
	    return;
	if (maxp < 2) { // ԡ1Ĥξ
	    Mu[0] = new Multiple(0, bsk, Pk2[0]);
	    ICount = 1;
	    PIT = ftoc(bsk, Pk2[0].getPfreq());
	    return;
	}

	double[] dfs = new double[Pmax]; // ¸
	double[] Df = new double[Pmax];
	int[] p0 = new int[Pmax];
	int[] k0 = new int[Pmax];
	int[] m0 = new int[Pmax];
	int[] px = new int[Pmax]; // Peak#
	int[] kx = new int[Pmax]; // key#
	int[] mx = new int[Pmax]; // multi#

	int k, m, cnt, mlen = Multi.length;
	double f0, c0, c1, df, sum0;
	double ce = StartIH, sum = 0, ih = 0, min = 1200;
	while (ce < ValIH) { // ׻inhaκ(0.017.0)
	    sum0 = cnt = 0;
	    dfs = new double[Pmax];  // 󥯥ꥢ
	    p0 = new int[Pmax];
	    m0 = new int[Pmax];
	    k0 = new int[Pmax];
	    for (int i = 0; i < mlen; i++) { // 20ܲޤ
		k = bsk+Multi[i];  // ܲΥֹ
		if (k > KC)        // 祭ֹǥѥ
		    break;
		m = i+1;           // ܲ
		f0 = getIFreq(k, ce, m); // Υդȿ
		c0 = ftoc(k, f0);        // cent

		for (int j = 0; j < maxp; j++) { // ԡ
		    c1 = ftoc(k, Pk2[j].getPfreq())+Ladder[i]; // դcent
		    df = c0-c1;                               // η׻(+-)
		    if (df < Cmax & df > -Cmax) { // ϰʤ...
			p0[cnt] = j;    // Peak#
			m0[cnt] = i;    // ܲ#
			k0[cnt] = k;    // key#
			dfs[cnt] = df;  // ¸
			cnt++;          // Υ󥿡
			break; // ϰ⤬ΤǤܿϽλ
		    }
		}
	    }
	    sum0 = calc_diff_sum(dfs); // κι
	    if (MaxSum < sum0) // ͤ¸
		MaxSum = sum0;
	    MinSum[SCount++] = sum0; // Υǡ

	    if (min > sum0) { // Ǿͤξ
		min = sum0;
		ih = ce;   // ͤ¸
		Df = dfs;  // ¸
		px = p0;  // Pitch#
		mx = m0;  // Multi#
		kx = k0;  // Key#
		ICount = cnt;  // ܲ¸
	    }

	    ce += dt; // ͤ
	} // whileλ

	for (int i = 0; i < Pmax; i++) { // ǾͤΥǡ
	    if (Df[i] == 0) // +-б
		continue;
	    sum += Df[i];  // ι
	    Mu[i] = new Multiple(mx[i], kx[i], Pk2[px[i]]); // new
	}
	sum /= ICount;  // ʿͤ(pitch)
	PIT = sum;
	INH = ih;

	calc_lsm2(Mu);
	kettei(Mu);
    }
    public double getIFreq(int k, double ih, int mul) {
	return ctof(getFreq(k), calc_inha(ih, mul));
    }
    public double calc_inha(double ce, int mul) {
	return ce*mul*mul;
    }
    public double getIfreq(double fr, int mul) {
	return ctof(fr*mul, calc_inha(INH, mul));
    }
    public void kettei(Multiple[] mu) {
	double sum0 = 0, sum1 = 0, sum2 = 0;
	int n = 0;

	for (int i = 0; i < mu.length; i++) {
            if (mu[i] == null)
                continue;
	    sum0 += Math.pow(mu[i].getCpure()-
			     (LsmA+LsmB*Math.pow(i+1, 2)), 2);
	    sum1 += mu[i].getCpure();
	    n++;
	}
	sum1 /= n;

	for (int i = 0; i < mu.length; i++) {
            if (mu[i] == null)
                continue;
	    sum2 += Math.pow(mu[i].getCpure()-sum1, 2);
	}

	LsmR = 1-sum0/sum2; // 그
    }
    public void calc_lsm2(Multiple[] mu) {
        double y, z, s1 = 0, s2 = 0, s3 = 0, yb = 0;
        int x, n = 0;

        for (int i = 0; i < mu.length; i++) {
            if (mu[i] == null)
                continue;
            x = mu[i].getMulti()+1; // ܿ
            y = mu[i].getCpure();   // cent
            s1 += x*x;
            s2 += Math.pow(x, 4);
	    s3 += x*x*y;
            yb += y;
            n++;
        }
	z = n*s2-Math.pow(s1, 2);
        LsmA = (s2*yb-s1*s3)/z;  // a(+bX^2)
        LsmB = (n*s3-(s1*yb))/z; // b
    }
    public double calc_diff_sum(double[] df) {
	double sum = 0;
	double d0 = df[0];               // κǽ
	for (int i = 1; i < Pmax; i++) { // 
	    if (df[i] == 0)              // +-б
		continue;
	    sum += Math.abs(d0-df[i]);   // κ
	}  // ǾˤʤϤ

	return sum;
    }
    public int get_funda_key(int key, boolean sw) {
	boolean fund = false;      // ̵ͭå

	int sk = is_skey(key, sw); // (or Auto)Keyԡ?
        if (key > 28) { // c28ʾ
	    if (sk < 0) // ̵н
		return -1;
	} else {
	    if (sk < 0) // ̵򥭡
		fund = true;
	}
	return fund ? key : Pk2[sk].getPkey();
    }
    public int is_skey(int key, boolean sw) { // skeyPeak˥?
	if (Pk2 == null)
	    return -1;

	if (sw) { // manu
	    for (int i = 0; i < getPnum(); i++) {
                if (Pk2[i].getPkey() == key)
                    return i;
            }
            return -1;
        } else
	    return 0;
    }
    //
    public void sort() { // not 0
	if (Pitch2.getPcounter() < 2)
	    return;
	quick_sort(0, Pitch2.getPcounter()-1);
    }
    public void quick_sort(int left, int right) {
	int l_index = left;
	int r_index = right;
	double pivot = Pk2[(left+right)/2].getPfreq();
	Pitch2 Temp;

	while (l_index <= r_index) {
	    for ( ; Pk2[l_index].getPfreq() < pivot; l_index++)
		;
	    for ( ; Pk2[r_index].getPfreq() > pivot; r_index--)
		;
	    if (l_index <= r_index) {
		Temp = Pk2[l_index];
		Pk2[l_index] = Pk2[r_index];
		Pk2[r_index] = Temp;
		l_index++;
		r_index--;
	    }
	}
	if (r_index > left)
	    quick_sort(left, r_index);
	if (l_index < right)
	    quick_sort(l_index, right);
    }
    //
    public int ftok(double sf) {
	int key = (int)Math.rint(Oct*log_base(2,sf/getFreq(0)));
	if (key >= KC)
	    key = KC-1;

	return key;  
    }
    public double log_base(double base, double value) {
        return Math.log(value)/Math.log(base);
    }
    public double ctof(double f, double cent) {
        return f*Math.pow(10, cent*ML);
    }
    public double ftoc(int keyn, double f) {
        return MC*Math.log(f/getFreq(keyn));
    }
    public double getFreq(int key) {
        key++;  // 0~87
        return AA*Math.pow(2, (key-49)/(double)Oct);
    }
    //
    public void initHanning() {
	Han = new double[NN];
	double rn = 1.0/NN;

        for (int i = 0; i < NN; i++)
	    Han[i] = 0.5-0.5*Math.cos(PI2*i*rn);
    }
    public void hanning(int[] data) {
        for (int i = 0; i < NN; i++) {
	    Re[i] = data[i]*Han[i];
	    Im[i] = 0;
	}
    }
    public void fft(int[] data) {
	Re = new double[NN];
        Im = new double[NN];

	hanning(data);
	fftN.fft(Re, Im);
        for (int i = 0; i < N2; i++) {
	    YY[i] = Math.sqrt(Re[i]*Re[i]+Im[i]*Im[i]);
	    if (YY[i] > Ymax) {
		Ymax = YY[i];
		Maxf = i;
	    }
	}
    }
}