/* $Id: JP.java,v 1.32 2011/10/11 06:18:38 mit Exp $ */
/* JP.java v0.3 */
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.sound.sampled.*;
import java.text.DecimalFormat;

public class JP extends JPanel
    implements ActionListener, AdjustmentListener, ChangeListener,
	       MouseListener, MouseMotionListener, Runnable
{
    private JComboBox chSmpl;     // ץ󥰿
    private JComboBox chDevid;
    private JComboBox chSpeed;    // 
    private JTextField tfA;       // error etc.
    private JTextField tfForm;
    private JButton jbLoad;
    private JButton btGO;         // go
    private JButton btCX;         // cent x2
    private JButton btCZ;         // cent /2
    private JButton[] btGrap;
    private JButton btTX;         // grap/text
    private JButton btP, btM;     // +,-
    private JButton btW, btN;     // >,<
    private JButton btAuto;
    private JScrollBar scrKey;    // limit etc.
    private JScrollBar scrWide;   // for wave 
    private JSlider scrVert;
    private JTextArea taA;
    private JPanel Deck;
    private CardLayout Card;
    private Thread thr;
    private static JFrame Frame;

    static final int KB = 88;
    static final int Oct = 12;
    static final int WAVE = 0;      // GRAP wave
    static final int FFT_ = 1;      // " fft 
    static final int PEAK = 2;      // " peak
    static final int INHA = 3;      // " inharmo.
    static final int DIFF = 4;      // " diff
    static final int CENT = 5;      // " cent
    static final int MinIH = 10;    // diff min(0.1)
    static final int MaxIH = 70;    // diff max(0.7)
    static final double SMaxVal = Short.MAX_VALUE;
    static final String[] Dev = {"1/1", "1/2", "1/4", "1/8", "1/16", "1/32"};
    static final String[] Graps = {"Wave","FFT_","Peak","Inha."};
    static final String[] Keynm =
    {"A..","B..","H..","C..","Cis","D..","Es.","E..","F..","Fis","G..","Gis"};
    static final int[] Sped = {0, 1, 2, 3, 4, 5, 6, 7 ,8 ,9};
    static final int[] Spnm = {9, 10, 11, 12, 13, 14, 15}; 

    boolean CALC;
    boolean IHsw;      // calc_Inharmo
    boolean GTsw;      // graph./text
    boolean Msw;       // mouse click
    boolean AutoSW;    // auto/manu sw.
    boolean DragSW;
    boolean FftSW;     // FFT_doubled
    boolean WaveSW;
    boolean DEBUG = false; // for debug
    int W;             // 
    int H;             //
    int H2;            // Hsft/2
    int FNT = 12;      // font size
    int GRAP;          // graph. select
    int Splngf;        // data sampling frq.
    int Sph;           // Splngf/2 ()
    int WaveDataN;     // wave ǡ
    int Cnt;           // wave ɽϰϿ
    int Start;         // wave ɽϰ
    int Firstx, Lastx; // for mouse dragg
    int Firstp, Lastp; // FFT åϰ
    int NB;            // n (9:512 10:1024 11:2048 12:4096 13: 14:)
    int NN;            // 2^n
    int N2;            // NN/2 (fft)
    int Xby;           // xΨ(2)
    int Hsft;          // 
    int PeakLimit;     // peak clip
    int MX;            // mouse x
    int Cmax;          // inh. cent max
    int KEY;
    int Level;         // åԥ
    int ValIH;         // for diff
    int IHsave;
    int LVsave;
    int PKsave;
    int FftCnt;
    int WaveCnt;
    int Stime;
    double Wdf;        // (W-1)/(Sph/Xby)
    double Wdn;        // (W-1)/(N2/Xby)
    double Wby;        // wave gain
    double Yby;        // fft gain
    double Wbase;
    double Ybase;
    double Ymax;       // fft max 
    double CX;         // cent x2  
    double Vnum;       // Hsft/Frame
    double Vsize;      // splng_v
    double Dwave;      // W/Cnt 
    double Cby;        // ih.cent
    int[] Wdat;        // all wave data
    String[] Filenm;
    String Error;
    String Dirnm;
    AudioFormat AFormat;

    PaintGraph PG;
    WaveReader WR;
    CalcPitch CP;
    DecimalFormat df1, df2;
    Graphics gi;
    Image ig;
    Font Fnt, Fns;
    FontMetrics fm;

    public JP() {
        PG = new PaintGraph();
        buildLayout();

        Border border = new BevelBorder(BevelBorder.RAISED);
        String name = "JP";
        border = new TitledBorder(border, name);
        setBorder(border);
    }
    public static void main(String[] argv) {
        JP jp = new JP();

	Frame = new JFrame();
        Frame.getContentPane().add(jp);
        Frame.pack();
        Frame.setSize(500, 420);
        Frame.setVisible(true);
        Frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    }
    public void buildLayout() {
	Fnt = new Font("SansSerif", Font.PLAIN, FNT);
	Fns = new Font("SansSerif", Font.PLAIN, FNT);
	setFont(Fnt);
	fm = getFontMetrics(Fnt);

        setLayout(new BorderLayout());
	df1 = new DecimalFormat("#0.0##");
	df2 = new DecimalFormat("#0.0#");
	//-----------south

	JPanel Ps = new JPanel();
        Ps.setLayout(new GridLayout(3,1,0,0));
        add(Ps, "South");

	JPanel s0 = new JPanel();
	s0.setLayout(new GridLayout(1,2,0,0));
	Ps.add(s0);

	scrKey = new JScrollBar(Scrollbar.HORIZONTAL, 0,0,0,0);
	scrKey.setBlockIncrement(2);
	scrKey.addAdjustmentListener(this);
        s0.add(scrKey);

	s0.add(new Label(": Key"));

	JPanel s1 = new JPanel();
	s1.setLayout(new GridLayout(1,2,0,0));
	Ps.add(s1);

	s1.add(new Label("Wide :", Label.RIGHT));

	scrWide = new JScrollBar(Scrollbar.HORIZONTAL, 0,0,0,0);
	scrWide.addAdjustmentListener(this);
	s1.add(scrWide);

	tfForm = new JTextField(20);
	tfForm.setFont(Fns);
	tfForm.setEditable(false);
        Ps.add(tfForm);
	//-------------north

	JPanel Pn = new JPanel();
	Pn.setLayout(new GridLayout(2,1,0,0));
	add(Pn, "North");

	JPanel n1 = new JPanel();
	n1.setLayout(new FlowLayout());
	Pn.add(n1);

	tfA = new JTextField(28);
	tfA.setFont(Fns);
        tfA.setForeground(Color.blue);
        tfA.setEditable(false);
        n1.add(tfA);

	n1.add(new Label(""));

        jbLoad = new JButton("Load");
        jbLoad.addActionListener(this);
        n1.add(jbLoad);
	//---

	JPanel n2 = new JPanel();
	n2.setLayout(new FlowLayout());
	Pn.add(n2);

	btGO = new JButton(" GO ");
        btGO.addActionListener(this);
        n2.add(btGO);

	Integer spd[] = new Integer[Sped.length];
	for (int i = 0; i < Sped.length; i++)
	    spd[i] = new Integer(Sped[i]);
	chSpeed = new JComboBox(spd);
	chSpeed.setSelectedItem(spd[Sped.length-1]); // 9 
	chSpeed.addActionListener(this);
	n2.add(chSpeed);

	n2.add(new Label(":"));

	NB = 12;
	Integer sam[] = new Integer[Spnm.length];
        for (int i = 0; i < Spnm.length; i++)
            sam[i] = new Integer(Spnm[i]);
	chSmpl = new JComboBox(sam);      // NN
	chSmpl.setSelectedItem(sam[3]);   //  12
        chSmpl.addActionListener(this);
        n2.add(chSmpl);

	chDevid = new JComboBox(Dev);
        chDevid.addActionListener(this);
	n2.add(chDevid);

	n2.add(new Label(""));

	btCZ = new JButton("C/");
        btCZ.addActionListener(this);
        n2.add(btCZ);

	btCX = new JButton("Cx");
        btCX.addActionListener(this);
        n2.add(btCX);
	//-----------east
	
	JPanel Pe = new JPanel();
	Pe.setLayout(new GridLayout(1,2,0,0));
	add(Pe, "East");

	JPanel e1 = new JPanel();
	e1.setLayout(new GridLayout(1,1,0,0));
	Pe.add(e1);

	scrVert = new JSlider(JSlider.VERTICAL, 1, 100, 10);
	scrVert.setPaintTicks(true);
	scrVert.setPaintLabels(false);
        scrVert.setMajorTickSpacing(10);
        scrVert.addChangeListener(this);
	e1.add(scrVert);

	JPanel e2 = new JPanel();
	e2.setLayout(new GridLayout(5,1,0,0));
	Pe.add(e2);

        btP = new JButton("+");
        btP.addActionListener(this);
        e2.add(btP);

	btM = new JButton("-");
        btM.addActionListener(this);
        e2.add(btM);

	e2.add(new Label(""));

	btN = new JButton("<");
        btN.addActionListener(this);
        e2.add(btN);

	btW = new JButton(">");
        btW.addActionListener(this);
        e2.add(btW);
	//----------west

	JPanel Pw = new JPanel();
	Pw.setLayout(new GridLayout(Graps.length+2,1,0,0));
        add(Pw, "West");

	btGrap = new JButton[Graps.length];
	for (int i = 0; i < Graps.length; i++) {
	    btGrap[i] = new JButton(Graps[i]);
	    btGrap[i].addActionListener(this);
	    Pw.add(btGrap[i]);
	}

	btTX = new JButton("Grap.");
        btTX.addActionListener(this);
        Pw.add(btTX);

	btAuto = new JButton("Auto.");
        btAuto.addActionListener(this);
        Pw.add(btAuto);
	//-------center

	Deck = new JPanel();
        Card = new CardLayout();
        Deck.setLayout(Card);

	JScrollPane graph = new JScrollPane(PG);
        Deck.add(graph, "graph");

	taA = new JTextArea("");
	taA.setFont(Fns);
        taA.setEditable(false);

	JScrollPane text = new JScrollPane(taA);
        Deck.add(text, "text");
        add(Deck, "Center");

        PG.addMouseListener(this);
        PG.addMouseMotionListener(this);

	init_data();
    }
    public void init_data() {
	Xby = 2;
	Ybase = 1/(double)Short.MAX_VALUE/50;
	Wbase = 1/(double)Short.MAX_VALUE;
	Cby = 1;
	CX = 50.0;
	Cmax = 50;  // diff˻
	ValIH = 30; // 1/10
	Level = 10; // %
	KEY = 49-1;
	Stime = 10; // sleep time
	Error = "";

	CP = new CalcPitch();
	set_nn();
	set_scrKey();
	enable_set();
    }
    public void read_file() {
	setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR)); // 
	read_data();

	if (Error == null) {
	    Start = 0;
	    Cnt = WaveDataN;
	    averge();

	    Sph = Splngf/2;
	    Ymax = 0;
	    CP.initPitch(Wdat, Splngf, NN, get_devid(),
			 Cnt, Start, PG.calc_level(), Cmax);
	    CP.reset_peak();
	    set_devid();
	} else {
	    Cnt = 0;
	}
	IHsw = false;

	setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    }
    public void averge() {
	double sum = 0;

	for (int i = 0; i < WaveDataN; i++)
	    sum += Wdat[i];
	sum /= WaveDataN;
	for (int i = 0; i < WaveDataN; i++)
	    Wdat[i] = (int)(Wdat[i]-sum);
    }
    public void read_data() {
        WR = new WaveReader();
        Error = WR.getError();
        File f = WR.getFile();

        if (f != null && Error == null) {
	    AFormat = WR.getFormat();
            Splngf = WR.getSamplf();
            Wdat = WR.getData();
	    WaveDataN = Wdat.length;
        } else {
	    Wdat = null;
	    WaveDataN = 0;
	}
	write_format(AFormat);
	write_filenm(f);
    }
    public void write_format(AudioFormat f) {
        tfForm.setText((Error == null) ? ""+f : "error:"+Error);
    }
    public void write_filenm(File fn) {
	Frame.setTitle((Error == null) ? fn.getName() : "");
    }
    public void enable_set() {
	boolean wv = (!isWave());
	btGO.setEnabled(wv);

	boolean go = (thr == null);
	boolean gw = (GRAP == WAVE);
	boolean gf = (GRAP == FFT_);
	scrWide.setEnabled(wv && (gf || gw) && go);

	boolean gr = (GRAP == INHA);
	btCX.setEnabled(gr && go); // x2
	btCZ.setEnabled(gr && go); // /2

	boolean gt = (!GTsw);
	btW.setEnabled(wv && !(!go && gw) && gt); // >
	btN.setEnabled(wv && !(!go && gw) && gt); // <

	boolean gp = (GRAP == PEAK);
	boolean gc = (GRAP == CENT);
	scrKey.setEnabled(gp || gf || (gr && AutoSW));
	btP.setEnabled((gw || gc || gr || (gf && go)) && gt); // +
	btM.setEnabled((gw || gc || gr || (gf && go)) && gt); // -

	boolean gd = (GRAP == DIFF);
	scrVert.setEnabled((gp || gf || gd) && go);
    }
    public void set_nn() {
	NN = (int)Math.pow(2, NB);
	N2 = NN/2;
	PeakLimit = 0;

	CP.setSample(NN, get_devid());
	CP.reset_peak();
	set_devid();
    }
    public void set_count() {
	set_scrWave();

	if (CP != null) {
	    CP.setWide(Start, Cnt);
	    set_devid();
	    CP.reset_peak();
	}

	CALC = false;
    }

    public void mouseMoved(MouseEvent m) {
	if (!GTsw && Msw) { // not TEXT
	    if (GRAP != WAVE) { // waveʳ
		MX = m.getX();
		KEY = CP.ftok(MX/Wdf);
		IHsw = false; // calc. multiple

		if (AutoSW) // manu. not auto
		    scrKey.setValue(KEY);

		PG.repaint();
	    }
	}
    }
    public void mousePressed(MouseEvent m) { 
	if (!GTsw) { // not TEXT
	    switch (GRAP) {
	    case FFT_:
		Lastp = Firstp = get_fft_number(m.getX());
		CP.resetPower(); // ǽreset
		break;
	    case PEAK:
	    case INHA:
	    case CENT:
		Msw = !Msw;
		MX = m.getX();
		break;
	    case WAVE:
		Firstx = minmax_limit(m.getX());
		CALC = false;
		break;
	    default:
	    }
	    PG.repaint();
	}
    }
    public void mouseReleased(MouseEvent m) {
	switch (GRAP) {
	case WAVE:
	    DragSW = false;
	    Lastx = minmax_limit(m.getX());

	    int wid = (int)(Math.abs(get_LFD()));
            if (wid > NN)
                selected();
	    else
		DragSW = false;

	    PG.repaint();
	    set_count();
	    break;
        case FFT_:
	    Lastp = get_fft_number(m.getX());

	    if (isFftNotDragged())
		Msw = !Msw;

	    select_power();
	    if (Lastp-Firstp < 1)
		reset_power(); // ϰ0reset
	    else
		set_power();
	    
	    PG.repaint();
	    break;
	default:
	}
    }
    public boolean isFftNotDragged() {
	return (Lastp == Firstp);
    }
    public void mouseDragged(MouseEvent m) {
	switch (GRAP) {
	case WAVE: 
            DragSW = true;
	    Lastx = minmax_limit(m.getX());

            PG.repaint();
	    break;
        case FFT_:
	    Lastp = get_fft_number(m.getX());

	    PG.repaint();
	    break;
	default:
	}
    }
    public void mouseEntered(MouseEvent m) { }
    public void mouseExited (MouseEvent m) { }
    public void mouseClicked(MouseEvent m) { }
    public void select_power() {
	if (Lastp < Firstp) {
	    int x = Lastp;
	    Lastp = Firstp;
	    Firstp = x;
	}
    }
    public void set_power() {
	for (int i = Firstp; i < Lastp; i++)
	    CP.setPower(i);
    }
    public void reset_power() {
	CP.resetPower();
    }
    public int get_fft_number(int gx) {
	int mx = (int)(gx/Wdn);
	if (mx > N2)
	    mx = N2-1;
	if (mx < 0)
	    mx = 0;

	return mx; 
    }
    public int minmax_limit(int gx) {
	if (gx > W)
	    gx = W-1;
	if (gx < 0)
	    gx = 0;

	return gx;
    }
    public void selected() {
        if (Lastx < Firstx) {
            int x = Lastx;
            Lastx = Firstx;
            Firstx = x;
        }
        Start += (int)(Firstx/Dwave);
	Cnt = (int)get_LFD();

	set_count();
    }
    public double get_LFD() {
	return (Lastx-Firstx)/Dwave;
    }
    public void stateChanged(ChangeEvent e) {
	if (scrVert.getValueIsAdjusting()) { //
	    switch (GRAP) {
	    case FFT_:
		Level = scrVert.getValue();
		CP.setLevel(PG.calc_level());
		break;
	    case PEAK:
		PeakLimit = scrVert.getValue();
		break;
	    case INHA:
	    case DIFF:
		ValIH = scrVert.getValue();
		break;
	    default:
	    }
	}
	
	disp_sw();
    }
    public void adjustmentValueChanged(AdjustmentEvent e) {
	if (e.getSource() == scrWide) {
	    Start = scrWide.getValue();
	    set_count();
	}
	if (e.getSource() == scrKey) {
	    if (GRAP != WAVE) { // waveʳ
		KEY = scrKey.getValue();
		IHsw = false;
	    }
	}

	disp_sw();
    }
    public double getValueInh() {
	return ValIH/10.0;
    }
    public void set_scrollbar() {
	IHsave = ValIH;
	PKsave = PeakLimit;
	LVsave = Level;

	switch (GRAP) {
	case FFT_:
	    scrVert.setMinimum(1);
	    scrVert.setMaximum(100);
	    scrVert.setValue(LVsave);
	    scrVert.setMajorTickSpacing(10);
	    break;
	case PEAK:
	    scrVert.setMinimum(0);
	    scrVert.setMaximum(CP.getFrame());
	    scrVert.setValue(PKsave);
	    scrVert.setMajorTickSpacing(2);
	    break;
	case DIFF:
	    scrVert.setMinimum(MinIH);
	    scrVert.setMaximum(MaxIH+1);
	    scrVert.setValue(IHsave);
	    scrVert.setMajorTickSpacing(10);
	    break;
	default:
	}
    }
    public void set_scrWave() {
	scrWide.setValues(Start, Cnt, 0, WaveDataN);
	scrWide.setBlockIncrement(NN/2);
	scrWide.setUnitIncrement(NN/10);
    }
    public void set_scrKey() {
	scrKey.setValues(KEY, 1, 0, KB);
	scrKey.setBlockIncrement(Oct);
	scrKey.setUnitIncrement(1);
    }
    public void actionPerformed(ActionEvent e) {
	if (e.getSource() == jbLoad)
            read_file();

	else if (e.getSource() == btM)  // -
            set_val(false);
        else if (e.getSource() == btP)  // +
            set_val(true);

	else if (e.getSource() == btW)  // max.f /2
            set_wide(false);
        else if (e.getSource() == btN)  // max.f x2
            set_wide(true);

	else if (e.getSource() == btGO) // go
	    set_go();

	else if (e.getSource() == btGrap[WAVE]) {
	    GRAP = WAVE;
	    set_wave_button();
	} else if (e.getSource() == btGrap[FFT_]) {
	    GRAP = FFT_;
	    set_fft_button();
	} else if (e.getSource() == btGrap[PEAK]) {
	    GRAP = (GRAP == PEAK) ? CENT : PEAK;
	    set_peak_button();
	}
	else if (e.getSource() == btGrap[INHA]) {
	    GRAP = (GRAP == INHA) ? DIFF : INHA;
	    set_inha_button();
	}
	else if (e.getSource() == btTX) // graph./text
	    set_grap();

	else if (e.getSource() == btCX) // cent x
	    cent_by(true);
	else if (e.getSource() == btCZ) // cent / 
	    cent_by(false);

	else if (e.getSource() == btAuto)
	    set_auto();

	else if (e.getSource() == chSmpl) {  // sampling
	    NB = ((Integer)(chSmpl.getSelectedItem())).intValue();
	    set_nn();
	}

	else if (e.getSource() == chDevid)
	    set_devid();

	else if (e.getSource() == chSpeed)
	    set_speed();

	set_scrollbar();
	enable_set();
	disp_sw();
    }
    public void set_wave_button() {
	WaveCnt++;
	if (WaveCnt > 1) {
	    WaveSW = !WaveSW;
	    WaveCnt = 0;
	}
	resetFFT_button();
    }
    public void set_fft_button() {
	FftCnt++;
	if (FftCnt > 1) {
	    FftSW = !FftSW;
	    FftCnt = 0;
	}
	resetWave_button();
    }
    public void set_inha_button() {
	btGrap[INHA].setText((GRAP == INHA) ? "Inha." : "(diff)");
	resetFFT_button();
	resetWave_button();
    }
    public void set_peak_button() {
	btGrap[PEAK].setText((GRAP == PEAK) ? "Peak." : "(cent)");
	resetFFT_button();
	resetWave_button();
    }
    public void resetFFT_button() {
	FftCnt = 0;
    }
    public void resetWave_button() {
	WaveCnt = 0;
    }
    public void set_grap() {
	GTsw = !GTsw;
	btTX.setText(GTsw ? "Text" : "Grap.");
	Card.next(Deck);
    }
    public boolean isWave() {
	return Wdat == null;
    }
    public void set_go() {
	if (isWave())
	    return;

	if (thr == null) {
	    CP.startRun();
	    set_go_button(false);

	    thr = new Thread(this);
	    thr.start();
	} else {
	    CP.stop();
	    set_go_button(true);
	    thr = null;
	}	
    }
    public void set_go_button(boolean sw) {
	btGO.setText(sw ? " GO " : "Stop");
    }
    public void set_auto() {
	AutoSW = !AutoSW;
	btAuto.setText(AutoSW ? "Manu." : "Auto.");

	IHsw = false; // ؤǺƷ׻Ԥ
    }
    public void cent_by(boolean sw) {
	int min = 25;
	int max = 400;

	CX = (sw ? CX*2 : CX/2);
	if (CX > max)
	    CX = min;
	else if (CX < min)
	    CX = max;
    }
    public void set_val(boolean sw) {
	switch (GRAP) {
	case WAVE:
	    Wbase = sw ? Wbase*2 : Wbase/2;
	    break;
	case INHA:
	    int min = 10;
	    int max = 100;
	    int dc = 10;

	    Cmax = sw ? Cmax+dc : Cmax-dc;
	    if (Cmax > max)
		Cmax = min;
	    else if (Cmax < min)
		Cmax = max;

	    CP.setCmax(Cmax);
	    IHsw = false;
	    break;
	case FFT_:
	    double sq = Math.sqrt(2);
	    Ybase = sw ? Ybase*sq : Ybase/sq;
	    PG.set_Yby(); //
	    CP.setLevel(PG.calc_level());
	    break;
	case CENT:
	    Cby = sw ? Cby*2 : Cby/2;
	    break;
	default:
	}
    }
    public void set_wide(boolean sw) {
	switch (GRAP) {
	case WAVE:
	    Cnt = sw ? Cnt/2 : Cnt*2;
	    if (Cnt < NN)
		Cnt = NN;
	    else if (Cnt > WaveDataN) {
		Cnt = WaveDataN;
		Start = 0;
	    }
	    if (Start+Cnt > WaveDataN)
		Start = WaveDataN-Cnt;

	    set_count();
	    break;
	case FFT_:
	case PEAK:
	case INHA:
	case CENT:
	    int min = 1;
	    int max = 512;

	    Xby = sw ? Xby/2 : Xby*2;
	    if (Xby < min)
		Xby = min;
	    else if (Xby > max)
		Xby = max;
	    break;
	default:
	}
    }
    public void set_devid() {
	CP.setDevid(get_devid());

        CALC = false;
    }
    public int get_devid() {
	return chDevid.getSelectedIndex(); // 0~4
    }
    public void set_speed() {
	int sp = chSpeed.getSelectedIndex();
	Stime = 100-sp*10;
	CP.setStime(Stime);
    }
    //---

    public void run() {
        Error = "";
        CALC = false;

        setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR)); // 
	run_set_enable(false);
        try {
            while (CP.isRun()) {
                disp_sw();
                thr.sleep(Stime);
            }
        } catch (InterruptedException e) {
            Error = "Run error."; // System.out.println(e);
        } catch (Exception ex) {
	    Error = "run error";
	    CP.stop();

            ex.printStackTrace();
        }
        setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
	run_set_enable(true);
	set_go_button(true);

        thr = null;
        disp_sw();

        Error = (CP.getError() == null) ? Error : CP.getError();
        CALC = true;
        IHsw = false;
    }
    public void stop() {
        if (thr != null)
            thr = null;
    }
    public void run_set_enable(boolean sw) {
	chDevid.setEnabled(sw);
	chSmpl.setEnabled(sw);
	scrWide.setEnabled(sw);
	scrVert.setEnabled(sw);
	btP.setEnabled(sw);
	btM.setEnabled(sw);
	btCX.setEnabled(sw);
	btCZ.setEnabled(sw);
	btN.setEnabled(sw);
	btW.setEnabled(sw);
    }
    public void calc_() {
	CP.calc_one_time();
        CALC = true;
        IHsw = false;
    }
    public void disp_sw() {
	write_error();

	if (GTsw)
	    re_write();     // text
	else 
	    PG.repaint();  // graph.
    }

    public void write_error() {
	tfA.setText(Error == null ? "" : Error);
    }

    public String dform(double val) {
	return df1.format((float)val);
    }
    public String dform2(double val) {
	return df2.format((float)val);
    }
    //--------

    public void re_write() {
	switch (GRAP) {
	case WAVE:
	    write_wave();
	    break;
	case FFT_:
	    write_peak();
	    break;
	case PEAK:
	    write_pitch();
	    break;
	case INHA:
	    write_partial();
	    break;
	case DIFF:
	    write_diff();
	    break;
	case CENT:
	    write_cent();
	    break;
	default:
	}
    }
    public void write_wave() {
	StringBuilder str = new StringBuilder(1024);
	str.append("Audio_File_Format: \n");
	str.append("-----------------------------------------------------\n");
	str.append(AFormat);

	taA.setText(str.toString());
    }
    public void write_peak() {
	if (isWave())
	    return;

	StringBuilder str = new StringBuilder(1024);
	if (!CALC)
	    calc_();
	str.append(loop_());
	str.append(head_());
	for (int i = 0; i < CP.getALsize(); i++) {
	    str.append((i+1)+": ");
	    str.append(CP.getPeaksf(i)+"\n");	    
	}

	taA.setText(str.toString());
    }
    public String loop_() {
	StringBuilder str = new StringBuilder(256);
	str.append("Count:["+CP.getLoop()+"]/");
	str.append(CP.getFrame()+"\n");

	return str.toString();
    }
    public String head_() {
	StringBuilder str = new StringBuilder(1024);
	str.append("Sampling f."+Splngf);
	str.append(": Data num."+(CP.getLoop()*NN)+"/"+Cnt);
	str.append(": Sampl num."+NN+"\n");
	str.append("#: [Hz] Key#:  peak>");
	str.append(dform(PG.calc_level())+"(max:");
	str.append(dform(CP.getYmax())+")\n");
	str.append("------------------------------------\n");

	return str.toString();
    }

    public void write_pitch() {
	if (isWave())
	    return;
	if (!CALC)
	    calc_();

	StringBuilder str = new StringBuilder(1024);
   	str.append("["+PeakLimit+"]/");
	str.append((CP.getFrame())+"\n");
	str.append("#: Key#: count:  [Hz]\n");
	str.append("---------------------------\n");
	for (int i = 0; i < CP.getPitch(0).getPcounter(); i++) {
	    if (CP.getPitch(i) == null) {
		if (DEBUG)
		    System.out.println("write_pitch i: "+i);
		continue;
	    } else if (CP.getPitch(i).getPcount() >= PeakLimit) {
		str.append((i+1)+": ");
		str.append(CP.getPitch(i)+"\n");
	    }
	}

	taA.setText(str.toString());
    }
    public void write_partial() {
	if (isWave())
	    return;
	if (!CALC)
	    calc_();
	if (!IHsw) {
	    CP.calcInharmo(KEY, getValueInh(), AutoSW);
	    IHsw = true;
	}
	StringBuilder str = new StringBuilder(1024);
	String bar = "-------------------------------------------------\n";
	str.append("P#: Key#[count]:  [Hz]: c.equal: c.pure: I.const.\n");
	str.append(bar);

	int n = CP.getICount();
	if (n > 0) {
	    for (int i = 0; i < n; i++)
		str.append(write_inh(i));
	}
	str.append(bar);
	str.append(" ["+get_ip(n)+"]");
		
	taA.setText(str.toString());
    }
    public String write_inh(int n) {
	StringBuilder s = new StringBuilder(48);

	int pn = CP.getMultiple(n).getMulti();
	s.append((pn+1)+": ");
	s.append(CP.getMultiple(n).getPitch()+": ");
	s.append(dform(CP.getECent(n))+": "); // NullPointerException ?
	s.append(dform(CP.getICent(n))+": ");
	s.append((pn == 0) ? "---" : dform(CP.getInharmo(n))).append("\n");

	return s.toString();
    }
    public void write_diff() {
	if (isWave())
	    return;
	if (CP.getMinSum() == null)
	    return;

	StringBuilder s = new StringBuilder(48);
	int lensum = CP.getSumCount();
	double[] data = CP.getMinSum();
	double maxsum = CP.getMaxSum();
	for (int i = 0; i < lensum; i++) {
	    s.append(i+": ");
	    s.append(dform(data[i])+"\n");
	}
	s.append("-------------\n");
	s.append("diff_max:"+dform(maxsum));

	taA.setText(s.toString());
    }
    public void write_cent() {
	if (isWave())
	    return;

	int inh = CP.getICount();
	if (inh > 0)
	    write_inha_cent(inh);
	else
	    write_peak_cent();
    }
    public void write_peak_cent() {
	StringBuilder s = new StringBuilder(48);
	int k, c, c0 = 0;
	double f, ce;

	s.append("key:[cent]...\n");
	s.append("---------------------------\n");
	for (int i = 0; i < CP.getALsize(); i++) {
	    c = CP.getPeaksc(i);
	    if (c != c0)
		s.append("\n");
	    k = CP.getPeaksk(i);
	    f = CP.getPeaksf(i);
	    ce = CP.ftoc(k, f);    // centͤ
	    s.append(k+":");
	    s.append(dform(ce)+"\n");
	    c0 = c;
	}

	taA.setText(s.toString());
    }
    public void write_inha_cent(int n) {
	StringBuilder s = new StringBuilder(48);
	int keym, key, mul, kp, cn, count;
	double f, ce;
	boolean octave = true; // for Octave

	double allsec = Cnt/(double)Splngf;
	if (octave) {
	    s.append(dform(allsec)+"\n");
	} else {
	    s.append("Time: "+dform(allsec)+"[sec]\n");
	    s.append("#: Key[count]: [Hz]: [cent]...\n");
	    s.append("------------------------------\n");
	}

	for (int k = 0; k < n; k++) {
	    key = CP.getMultiple(k).getPkey();  // ܲΤ륭
	    mul = CP.getMultiple(k).getMulti(); // ܲ
	    if (octave) {
		s.append((mul+1)+" ");
		s.append((key+1)+" ");
	    } else {
		s.append((mul+1)+": ");
		s.append(CP.getMultiple(k).getPitch()+": ");
	    }

	    count = 0;
	    for (int i = 0; i < CP.getALsize(); i++) {
		kp = CP.getPeaksk(i);
		cn = CP.getPeaksc(i);
		if (kp == key) {
		    while (count < cn) { // 'NaN'Ŷ (for Octave)
			s.append("NaN ");
			count++;
		    }
		    keym = CP.getMultiple(k).getKey();  // ܲθΥ
		    f = CP.getPeaksf(i);
		    ce = CP.ftoc(keym, f)+CP.getLadder(mul); // keym
		    s.append(dform(ce)+" ");
		    count++;
		}
	    }
	    s.append("\n");
	}

	taA.setText(s.toString());
    }
    public String get_ip(int n) {
	StringBuilder str = new StringBuilder(40);
	if (n > 0)
	    str.append("Pitch:"+dform(CP.getLsmA()));
	if (n > 1) {
	    str.append(" Inharmo.:"+dform(CP.getLsmB()));
	    str.append(" ("+dform(CP.getLsmR())+")");
	    // str.append("["+dform(CP.getINH())+"]");
	} else
	    str.append("...");

	return str.toString();
    }
    //---

    public class PaintGraph extends JPanel {
	final Color darkMagenta = new Color(180, 0, 150);
	final Color darkGreen = new Color(80, 228, 80);    
	final Color darkBlue = new Color(80, 80, 228);
	final Color darkRed = new Color(230, 30, 30);
	final Color Violet = new Color(90, 120, 160);
	final Color Bar = new Color(64, 128, 255);

        public PaintGraph() {
            setBackground(Color.black);
        }
        public void paintComponent(Graphics g) {
            Dimension d = getSize();
            W = d.width;
            H = d.height;
	    Hsft = H-FNT*3;
	    H2 = Hsft/2;
	    set_Yby();
	    Wby = H2*Wbase;
	    Wdf = W/(double)(Sph/Xby);
	    Wdn = W/(double)(N2/Xby);
	    Vsize  = Hsft/(double)CP.getFrame();

	    super.paintComponent(g);

	    switch (GRAP) {
	    case WAVE:
		disp_wave(g);
		break;
	    case FFT_:
		disp_rule(g);
		disp_fft(g);
		break;
	    case PEAK:
		disp_rule(g);
		disp_peak(g);
		break;
	    case INHA:
		disp_rule(g);
		disp_pitch(g);
		disp_inhar(g);
		break;
	    case DIFF:
		disp_minsum(g);
		break;
	    case CENT:
		disp_rule(g);
		disp_cent(g);
		break;
	    default:
	    }

	    //System.out.println("MaxFFT: "+CP.getMaxf());
	}
	public void set_Yby() {
	    Yby = Hsft*Ybase;
	}
	public void disp_key(Graphics g) {
	    int key = get_key();
	    g.setColor(Color.red);
	    g.fillRect((int)(CP.getFreq(key)*Wdf), Hsft, (int)(Wdn+1), 4);
	}
	public int get_key() {
	    return AutoSW ? KEY : CP.getFundKey();
	}
	public void disp_wave(Graphics g) {
	    g.setColor(Color.gray);
	    g.drawLine(0, H2, W, H2);   // center line
	    g.drawLine(0, Hsft, W, Hsft); // bass line

	    Dwave = W/(double)Cnt;
	    int val, max = Integer.MIN_VALUE, min = Integer.MAX_VALUE;
	    int x0, y0, x1 = 0, y1 = 0;
	    g.setColor(Color.green);
	    for (int i = 0; i < Cnt; i++) {
		val = Wdat[i+Start];
		x0 = (int)(Dwave*i);
		y0 = (int)(H2-val*Wby);
		if (i == 0) {
		    x1 = x0;
		    y1 = y0;
		}
		g.drawLine(x0, y0, x1, y1);
		x1 = x0;
		y1 = y0;
		max = Math.max(max, val);
		min = Math.min(min, val);
	    }

	    disp_time(g);
	    disp_nn_wide(g);
	    if (!WaveSW)
		disp_wave_value(g, min, max);
	    write_text(0);
	    if (DragSW)
		disp_cursor(g);
	}
	public void disp_cursor(Graphics g) {
	    if (Math.abs(get_LFD()) < NN)
		g.setColor(Color.red);
	    else
		g.setColor(Bar);
	    g.drawLine(Firstx, 0, Firstx, H);
	    g.drawLine(Lastx, 0, Lastx, H);
	}
	public void disp_nn_wide(Graphics g) {
	    int h = 2;
	    double dn = Dwave*NN;
	    double wsize = W/(double)CP.getFrame();
	    g.setColor(Color.orange);
	    g.drawRect((int)(wsize*CP.getLoop()), Hsft-1, (int)dn, h);
	}
	public void disp_wave_value(Graphics g, int min, int max) {
	    g.setColor(Color.lightGray);
	    g.drawString(dform2(100*max/SMaxVal), 1, (int)(H2-max*Wby));
	    g.drawString(dform2(100*min/SMaxVal), 1, (int)(H2-min*Wby+FNT));
	    g.drawString("[%]", 40, FNT);
	}
	public void disp_time(Graphics g) {
	    double allsec = Cnt/(double)Splngf;
	    double tim = get_tim(allsec);

	    String s = "[sec] ";
	    g.setColor(Color.yellow);
	    g.drawString(s, W-fm.stringWidth(s), H-FNT*2);

	    double asec = tim/(allsec/W);
	    int maxsec = (int)(allsec/tim);
	    if (maxsec > 0) {
		int ss = H-FNT;  // ʸh
		int x, l = 5;
		for (int i = 0; i <= maxsec; i++) {
		    x = (int)(asec*i);

		    g.setColor(Color.gray);
		    g.drawLine(x, Hsft, x, Hsft+l);

		    g.setColor(Color.yellow);
		    g.drawString(dform(i*tim), x, ss);
		}
	    }
	}
	public void disp_vtime(Graphics g) {
	    double allsec = CP.getDevidTime();
	    double tim = get_tim(allsec);

	    String s = "[sec] ";
	    g.setColor(Color.yellow);
	    g.drawString(s, W-fm.stringWidth(s), H-FNT);

	    double asec = tim/(allsec/Hsft);
	    int maxsec = (int)(allsec/tim);
	    if (maxsec > 0) {
		int ss = W-30;  // ʸx
		int y, l = 5;
		for (int i = 0; i <= maxsec; i++) {
		    y = (int)(asec*i);

		    g.setColor(Color.gray);
		    g.drawLine(W, y, W-l, y);

		    g.setColor(Color.yellow);
		    g.drawString(dform(i*tim), ss, y+FNT);
		}
	    }
	}
	public double get_tim(double allsec) {
	    double tim;

	    if (allsec < 0.1)
		tim = 0.01;
	    else if (allsec < 0.3)
		tim = 0.05;
	    else if (allsec < 1)
		tim = 0.1;
	    else if (allsec < 3)
		tim = 0.5;
	    else if (allsec < 10)
		tim = 1;
	    else if (allsec < 30)
		tim = 5;
	    else if (allsec < 60)
		tim = 10;
	    else
		tim = 60;

	    return tim;
	}
	public void write_text(int n) {
	    if (n < 0)
		return;

	    StringBuilder and = new StringBuilder(32);
	    switch(GRAP) {
	    case WAVE:
		and.append(Cnt+"/"+WaveDataN);
		and.append(" ["+NN+"]:"+NB);
		break;
	    case FFT_:
		and.append(dform(MX/Wdf)+"[Hz]:");
		and.append(dform(CP.getPower(n)));
		and.append(" ("+dform(calc_level())+")");
		break;
	    case PEAK:
		and.append((n+1)+":");
		if (CP.getPitch(n) == null) {
		    if (DEBUG)
			System.out.println("write_text n:"+n);
		    and.append("* null *");
		} else
		    and.append(CP.getPitch(n)+"[Hz]");
		break;
	    case INHA:
		and.append(get_keyname(get_key())+" ");
		and.append(get_ip(n));
		break;
	    case DIFF:
		if (CP.getMinSum() == null)
		    return;
		and.append("max:"+dform(CP.getMaxSum()));
		and.append(" inha.:"+dform(CP.getINH())); // CP.getLsmB()ǤϤʤ
		and.append(" #:"+n);
		break;
	    default:
	    }

	    tfA.setText(and.toString());
	}
	public String get_keyname(int key) {
	    return (key < 0) ? "" : (key+1)+Keynm[key%Oct];
	}   
	public void disp_rule(Graphics g) {
	    int mej, dx, max = Sph/Xby;

	    for (int i = 0; i <= max; i += 10) { // ȿ
		if (i%10000 == 0) {
		    mej = 20;
		    if (max >= 10000)
			disp_k(g, i, (int)(i*Wdf), H-FNT);
		} else if (i%5000 == 0) {
		    mej = 17;
		    if (max >= 5000)
			disp_k(g, i, (int)(i*Wdf), H-FNT);
		} else if (i%1000 == 0) {
		    mej = 14;
		    if (max < 12000)
			disp_k(g, i, (int)(i*Wdf), H-FNT);
		} else if (i%500 == 0) {
		    if (max > 23000)
			continue;
		    mej = 11;
		} else if (i%100 == 0) {
		    if (max > 12000)
			continue;
		    mej = 8;
		} else if (i%50 == 0) {
		    if (max > 4000)
			continue;
		    mej = 5;
		} else if (i%10 == 0) {
		    if (max > 2000)
			continue;
		    mej = 2;
		} else
		    continue;

		dx = (int)(i*Wdf);
		g.setColor(Color.gray);
		g.drawLine(dx, Hsft, dx, Hsft+mej);
	    } 
	
	    g.setColor(Color.gray);
	    g.drawLine(0, Hsft, W, Hsft);
	}
	public void disp_k(Graphics g, int k, int x, int y) {
	    g.setColor(Color.pink);
	    g.drawString(k/1000+"k", x, y);
	}
	public void disp_fft_cursor(Graphics g) {
	    if (isFftNotDragged())
		return;

	    int fp = get_fft2freq(Firstp);
	    int lp = get_fft2freq(Lastp);

	    g.setColor(Color.white);
	    g.drawLine(fp, 0, fp, H);
	    g.drawLine(lp, 0, lp, H);
	}
	public void disp_fft_max(Graphics g) {
	    int xf = (int)(Wdn*CP.getMaxf());

	    g.setColor(Color.yellow);
	    g.fillRect(xf, Hsft, (int)(Wdn+1), 6);
	}
	public int get_fft2freq(int p) {
	    return (int)(p*Wdn);
	}
	public void disp_fft(Graphics g) { 
	    disp_fft_memori(g);

	    if (isWave())
		return;
	    if (!CALC)
		calc_();

	    g.setColor(darkMagenta);
	    int lev = (int)(Hsft-rev_level());
	    g.drawLine(0, lev, W, lev); // ԡ

	    int mxf = CP.getMaxf();
	    int v1, x1, v0 = 0, x0 = 0;
	    for (int i = 0; i < N2/Xby; i++) {
		v1 = (int)(CP.getPower(i)*Yby);
		x1 = (int)(Wdn*i);
		if (CP.isPower(i))
		    g.setColor(Color.white);
		else if (MX >= x1 && MX < x1+Wdn) {
		    write_text(i);
		    g.setColor(Color.pink);
		} else if (i == mxf)
		    g.setColor(Color.yellow);
		else
		    g.setColor(darkGreen);
		if (i == 0) {
		    v0 = v1;
		    x0 = x1;
		}
		if (FftSW)
		    g.drawLine(x0, Hsft-v0, x1, Hsft-v1);
		else
		    g.drawRect(x1, Hsft-v1, (int)Wdn, v1);
		v0 = v1;
		x0 = x1;
	    }

	    disp_key(g);
	    disp_fft_cursor(g);
	    disp_fft_max(g);
	}
	public void disp_fft_memori(Graphics g) {
	    int hi, num = 10, mw = fm.stringWidth("10");
	    double hd = Hsft/(double)num;

	    for (int i = 1; i <= num; i++) {  // memori
		hi = (int)(Hsft-hd*i);

		g.setColor(darkBlue);
		g.drawLine(0, hi, W, hi);
 
		g.setColor(darkRed);
		g.drawString(""+i, W-mw, hi+FNT);
	    }
	}
	public double rev_level() {
	    return Hsft*Level/100.0; // %ɽ
	}
	public int calc_level() {
	    return (int)(rev_level()/Yby);
	}
	public int search_pkdata() {
	    int max = CP.getPnum();
	    int p = -1;
	    for (int i = 0; i < max; i++) {
		try {
		    if (KEY == CP.getPitch(i).getPkey())
			p = i;
		} catch (Exception e) {
		    if (DEBUG)
			System.out.println("search_pkdata i: "+i+ "max: "+max);
		    continue;
		}
	    }
	    write_text(p);

	    return p;
	}
	public void disp_peak(Graphics g) {
	    disp_devid(g);

	    if (isWave())
		return;
	    if (!CALC)
		calc_();

	    int y, k, max, xk = -1, n = search_pkdata();
	    //if (n > 0 && CP.getPitch(n) == null) // ̵λ n-1
	    //if (CP.getPitch(n) == null)
	    //return;
	    if (n >= 0)
		xk = CP.getPitch(n).getPkey();
	    max = CP.getALsize();
	    for (int i = 0; i < max; i++) {
		try {
		    y = (int)(Vsize*CP.getPeaksc(i));
		    k = CP.getPeaksk(i);
		    g.setColor((xk >= 0 && k == xk) ?
			       Color.pink : darkGreen);
		    g.drawRect((int)(CP.getPeaksf(i)*Wdf), y,
			       (int)(Wdn+1), (int)Vsize);
		} catch (Exception e) {
		    if (DEBUG)
			System.out.println("disp_peak i: "+i+" max: "+max);
		    continue;
		}
	    }

	    disp_vtime(g);
	    disp_key(g);
	    disp_fft_max(g);
	}
	public void disp_pitch(Graphics g) {
	    if (isWave())
		return;
	    if (!CALC)
		calc_();

	    double iv;
	    int max = CP.getPitch(0).getPcounter();
 	    g.setColor(Violet);
	    for (int i = 0; i < max; i++) {
		try {
		    iv = CP.getPitch(i).getPcount()*Vsize;
		    g.drawRect((int)(CP.getPitch(i).getPfreq()*Wdf),
			       (int)(Hsft-iv), (int)(Wdn+1), (int)iv);
		} catch(Exception e) {
		    if (DEBUG)
			System.out.println("disp_pitch i: "+i+" max: "+max);
		    continue;
		}
	    }

	    disp_key(g);
	    disp_fft_max(g);
	}
	public void disp_devid(Graphics g) {
	    int hi;

	    g.setColor(Color.gray);
	    for (int i = 0; i <= CP.getFrame(); i++) { // memori
		hi = (int)(Vsize*i);
		g.drawLine(0, hi, 5, hi);
	    }
	}
	public void disp_inhar(Graphics g) {
	    int hs = Hsft/2;
	    double hd = hs/CX;
	    cent_rule(g, hs, hd);

	    if (isWave())
		return;

	    disp_devid(g);
	    if (!CALC)
		calc_();
	    if (!IHsw) {
		CP.calcInharmo(KEY, getValueInh(), AutoSW);
		IHsw = true;
	    }

	    int n = CP.getICount();
	    if (n > 0) {
		int mx = CP.getMultiple(n-1).getMulti(); // ܲ
		disp_lsm(g, hs, mx, hd);

		int wd = (int)(Wdn+1);
		int sr = 2;    // Υɥå
		int sd = sr*2; // "   ľ
		int d2 = 2;    // ⤵1/2
		int dh = d2*2; // ⤵
		int x0 = 0, y0 = 0, x1, y1;

		g.setColor(darkBlue);
		for (int i = 0; i < n; i++) {
		    x1 = (int)(CP.getMultiple(i).getPfreq()*Wdf);
		    y1 = (int)(CP.getICent(i)*hd); // c.pure
		    if (i == 0) {
			x0 = x1;
			y0 = y1;
		    }
		    g.setColor(darkBlue);      // ľ
		    g.drawLine((int)(x0+Wdn), hs-y0, x1, hs-y1);

		    g.setColor(Color.magenta); // .
		    g.fillRect(x1, hs-y1-d2, wd, dh);
		    x0 = x1;
		    y0 = y1;
		}
	    }
	    write_text(n);
	}
	public void disp_lsm(Graphics g, int hs, int mx, double hd) {
	    int x0, y0, x1 = 0, y1 = 0, ii;
	    int k = get_key();
	    double f = CP.getFreq(k); // 

	    g.setColor(Color.gray);
	    for (int i = 0; i < mx+1; i++) {
		ii = i+1;
		x0 = (int)(CP.getIfreq(f, ii)*Wdf);
		y0 = (int)(CP.calcLSM(ii)*hd);
		if (i == 0) {
		    x1 = x0;
		    y1 = y0;
		}
		g.drawLine(x1, hs-y1, x0, hs-y0);
		x1 = x0;
		y1 = y0;
	    }
	}
	public void disp_minsum(Graphics g) {
	    if (isWave())
		return;

	    int starti = (int)(CP.getStartIH()*10);
	    diff_rule(g, starti);
	    if (CP.getMinSum() == null)
		return;

	    int lensum = CP.getSumCount();  // ǡ
	    double[] data = CP.getMinSum(); // Υǡ
	    double maxsum = CP.getMaxSum(); // κ
	    int num = (-starti+ValIH)*10; // max(7.0/0.01) 

	    int x, y, x0 = 0, y0 = 0;
	    double dw = W/(double)num;
	    double dh = Hsft/maxsum;

	    g.setColor(Color.lightGray);
	    for (int i = 0; i < num; i++) {
		x = (int)(dw*i);
		if (i > lensum)
		    continue;
		y = (int)(Hsft-dh*data[i]);
		if (i == 0) {
		    x0 = x;
		    y0 = y;
		}
		g.drawLine(x0, y0, x, y);
		x0 = x;
		y0 = y;
	    }

	    disp_maxsum(g, maxsum);
	    write_text(lensum);
	}
	public void disp_maxsum(Graphics g, double max) {
	    String s = "max:"+dform(max);
	    g.setColor(Color.red);
	    g.drawString(s, W-fm.stringWidth(s), FNT);
	}
	public void diff_rule(Graphics g, int start) {
	    g.setColor(Color.gray);
	    g.drawLine(0, Hsft, W, Hsft);

	    int l, ix, ii = 0;
	    double dx = W/(double)(ValIH-start);  // -ʤΤ+

	    for (int i = start; i < ValIH; i++) { // -ʤΤǤΤޤ 
		ix = (int)(dx*ii++);

		if (i % 10 == 0) { // 1.0
		    l = 12;
		    g.setColor(Color.pink);
		    g.drawString(dform(i/10.0), ix, H-FNT);
		} else if (i % 5 == 0) { // 0.5
		    l = 8;
		} else // 0.1
		    l = 6;

		g.setColor(Color.gray);
		g.drawLine(ix, Hsft, ix, Hsft+l);
	    }
	}
	public void cent_rule(Graphics g, int hs, double hd) {
	    g.setColor(Color.darkGray);   // center line
	    g.drawLine(0, hs, W-1, hs);

	    int mp, mm;
	    double hi;
	    g.setColor(Color.lightGray);
	    for (int i = 1; i < CX/10; i++) {  // cent memori
		hi = hd*i*10;
		mp = (int)(hs-hi);
		mm = (int)(hs+hi);
		g.drawLine(W-10, mp, W-1, mp);
		g.drawLine(W-10, mm, W-1, mm);
	    }

	    int ch = (int)(CX*hd);
	    String ps = ""+CX;
	    String ms = "-"+CX;
	    g.setColor(Color.orange);          // +-max
	    g.drawString(ps, W-fm.stringWidth(ps), hs-ch+FNT);
	    g.drawString(ms, W-fm.stringWidth(ms), hs+ch);

	    g.setColor(Color.yellow);
	    g.drawString("<"+Cmax, W-100, hs-ch+FNT);
	}
	public void disp_cent(Graphics g) {
	    if (isWave())
		return;
	    if (!CALC)
		calc_();

	    int inh = CP.getICount();
	    if (inh > 0)
		disp_inha_cent(g, inh);
	    else
		disp_peak_cent(g);

	    disp_key(g);
	}
	public void disp_peak_cent(Graphics g) {
	    disp_cent_momori(g);

	    double f, ce, fx;
	    int y, k, w = (int)(Wdn+1), h0 = (int)Vsize;
	    int h = (h0 > w) ? w : h0;

	    int xk = 0, n = search_pkdata();  // 륭
	    if (n < 0)
		xk = -1;
	    else if (CP.getPitch(n) == null) {
		if (DEBUG)
		    System.out.println("disp_peak_cent n: "+n);
		xk = -1;
	    } else
		xk = CP.getPitch(n).getPkey();

	    for (int i = 0; i < CP.getALsize(); i++) {
		y = (int)(Vsize*CP.getPeaksc(i));
		k = CP.getPeaksk(i);
		f = CP.getPeaksf(i);
		ce = CP.ftoc(k, f);     // c.equal
		fx = CP.getFreq(k)*Wdf;
		g.setColor(Color.gray);
		g.drawLine((int)fx, y, (int)fx, y+h0);

		g.setColor((xk >= 0 && k == xk) ?
			   Color.cyan : Color.yellow);
		g.drawOval((int)(fx+ce*Cby), y, w, h);
	    }
	}
	public void disp_inha_cent(Graphics g, int n) {
	    disp_cent_momori(g);

	    double f, ce, fx;
	    int keym, key, kp, x, y, mul, c0;
	    int w = (int)(Wdn+1), h0 = (int)Vsize;
	    int h = (h0 > w) ? w : h0;

	    int xk = 0, pk = search_pkdata();  // 륭
	    if (pk < 0)
		xk = -1;
	    else if (CP.getPitch(pk) == null) {
		if (DEBUG)
		    System.out.println("disp_inha_cent pk: "+pk);
		xk = -1;
	    } else
		xk = CP.getPitch(pk).getPkey();

	    for (int k = 0; k < n; k++) { // multiple
		key = CP.getMultiple(k).getPkey();  // peakKey
		for (int i = 0; i < CP.getALsize(); i++) {
		    c0 = CP.getPeaksc(i);
		    y = (int)(Vsize*c0);
		    kp = CP.getPeaksk(i);
		    if (kp == key) {
			fx = CP.getFreq(key)*Wdf;

			g.setColor(Color.gray);
			g.drawLine((int)fx, y, (int)fx, y+h0);

			keym = CP.getMultiple(k).getKey();  // multiKey
			mul = CP.getMultiple(k).getMulti(); // multiple
			f = CP.getPeaksf(i);
			ce = CP.ftoc(keym, f)+CP.getLadder(mul); // c.pure

			g.setColor((xk >= 0 && key == xk) ?
				   Color.cyan : Color.magenta);
			x = (int)(fx+ce*Cby);
			g.drawOval(x, y, w, h);
		    } // if
		} // ALsize
	    } // multi

	    disp_vtime(g);
	}
	public void disp_cent_momori(Graphics g) {
	    int x0, l = 8, max = 10;
	    double dx = W/(double)max;

	    String s = "|<"+(int)(W/Cby/max)+">|";
	    g.setColor(Color.red);
	    g.drawString(s, 1, H-FNT);

	    g.setColor(Color.lightGray);
	    for (int i = 0; i < max; i++) {
		x0 = (int)(dx*i);
		g.drawLine(x0, Hsft, x0, Hsft-l);
	    }
	}
    }
}