/* $Id: Multiple.java,v 1.2 2011/09/17 08:39:56 mit Exp $ */
/* Multiple.java v0.1 */

public class Multiple {
    private int Multi;     // ֹܲ 0~
    private int Key;       // ܲ
    private double Cequal; // equal cent
    private double Cpure;  // pure cent()
    private Pitch2 Pit;
    private static int Mcount; // ܲ

    private final int Oct = 12;
    private final int Cent = 1200;
    private final double AA = 440.0;
    private final double MC = Cent/Math.log(2);
    private final double[] Ladder = {
	0.0, 0.0, -1.955, 0.0, 13.6863, -1.955, 31.1741, 0.0,
	-3.91, 13.6863, 48.6821, -1.955, -40.5277, 31.1741,
	11.7313, 0.0, -4.9554, -3.91, 2.487, 13.6863}; // 20

    public Multiple() {
        Mcount = 0;
    }
    public Multiple(int mu, int key, Pitch2 pit) {
        setMultiple(mu, key, pit);
    }
    public void setMultiple(int mu, int key, Pitch2 pit) {
        Multi = mu;
	Key = key;
	Pit = pit;
	this.setCent(key);

	++Mcount;

	//System.out.println(Mcount+": "+mu+" "+Cequal+" "+Cpure);
    }
    public void setCent(int key) {
	Cequal = this.ftoc(key, Pit.getPfreq());
	Cpure = Cequal+Ladder[Multi];
    }
    public void setMcounter(int num) {
	Mcount = num;
    }
    //
    public int getMulti() {
	return Multi;
    }
    public double getInhar(double ce) {
	int m = Multi+1;
	return (Cpure+ce)/(m*m);
    }
    public int getPkey() {
        return Pit.getPkey();
    }
    public double getPfreq() {
        return Pit.getPfreq();
    }
    public Pitch2 getPitch() {
        return Pit;
    }
    public double getCpure() {
	return Cpure;
    }
    public double getCequal() {
	return Cequal;
    }
    public int getKey() {
	return Key;
    }
    public static int getMcounter() {
	return Mcount;
    }
    public static void resetMcounter() {
	Mcount = 0;
    }
    //
    public double ftoc(int key, double f) {
        return MC*Math.log(f/getFreq(key));
    }
    public double getFreq(int key) {
        key++;  // 0~87
        return AA*Math.pow(2, (key-49)/(double)Oct);
    }
    public String toString() {
        StringBuilder str = new StringBuilder();

        str.append(Multi+": ");
	str.append(Pit+" ");
	str.append((float)Cequal+" ");
	str.append((float)Cpure+" ");

        return str.toString();
    }
}