/* $Id: WaveReader.java,v 1.3 2011/10/11 06:15:50 mit Exp $ */
/* WaveReader.java */
import javax.swing.*;
import java.io.*;
import javax.sound.sampled.*;

public class WaveReader {
    private AudioInputStream AIS;
    private Byte2Data BD;

    private static int Samplf;
    private static int[] Wave;
    private static String Error;
    private static File Fname;
    private static AudioFormat Aformat;

    public WaveReader() {
	BD = new Byte2Data();

	file_open();
	if (Fname != null) {
	    try {		
		Wave = read_data(Fname, null);
		dc_cut();
	    } catch (VirtualMachineError OutOfMemoryException) {
		Error = "Out of memory";
	    } catch (Exception ex) { 
		ex.printStackTrace();
	    }
	}
    }
    public void dc_cut() {
	int len = Wave.length;
	double ave = 0;
	for (int i = 0; i < len; i++)
	    ave += Wave[i];
	ave /= len;
	for (int i = 0; i < len; i++)
	    Wave[i] -= ave;
    }
    //---

    public static File getFile() {
	return Fname;
    }
    public static int[] getData() {
	return Wave;
    }
    public static AudioFormat getFormat() {
        return Aformat;
    }
    public static int getSamplf() {
        return Samplf;
    }
    public static String getFileName() {
	return Fname.getName();
    }
    public static String getError() {
	return Error;
    }
    //---

    public void file_open() {
        JFileChooser fc = null;
        try {
            File fi = new File(System.getProperty("user.dir"));
            fc = new JFileChooser(fi);
            fc.setFileFilter(new javax.swing.filechooser.FileFilter() {
                    public boolean accept(File f) {
                        if (f.isDirectory())
                            return true;
                        String name = f.getName();
                        if (name.endsWith(".wav"))
                            return true;
                        return false;
                    }
                    public String getDescription() {
                        return ".wav";
                    }
                });

            if (fc.showOpenDialog(null) == JFileChooser.APPROVE_OPTION) {
                Fname = fc.getSelectedFile();
                try {
                    AudioFileFormat aff = AudioSystem.getAudioFileFormat(Fname);
		    Aformat = aff.getFormat();
		} catch(Exception e) {
                    e.printStackTrace();
                }
            }
        } catch (SecurityException ex) { 
            ex.printStackTrace();
        } catch (Exception ex) { 
            ex.printStackTrace();
        }
    }
    public int[] read_data(File fn, byte[] audioB) {
        createAudioInputStream(fn);
        AudioFormat format = AIS.getFormat();
        Samplf = (int)format.getSampleRate();

        if (audioB == null) {
            try {
                audioB = new byte[(int)(AIS.getFrameLength()*
                                        format.getFrameSize())];
                AIS.read(audioB);
		return BD.byte2data(audioB, format);
            } catch (Exception ex) {
		Error = ex.toString();
            }
        }
	return null;
    }
    public void createAudioInputStream(File file) {
        if (file != null && file.isFile()) {
            try {
                Error = null;
                AIS = AudioSystem.getAudioInputStream(file);
            } catch (Exception ex) {
		Error = ex.toString();
            }
        } else {
	    Error = "Audio file required.";
        }
    }
}